#One hop wireless video transmission
#Papapanagiotou and Zaoudis
#24-04-2009

#================================================================================
# General Parametres
#================================================================================
set opt(title)  		"802.11"	;
set opt(seed)		     13.37		;# general random seed for traffic flow
set opt(stop)     		55.0		;
set opt(verbose)        	1		;# 1 to print messages 0 to be silent
#================================================================================
#Channel properties
#================================================================================
set opt(chan)			  Channel/WirelessChannel
set opt(prop)			  Propagation/TwoRayGround;
set opt(netif)			Phy/WirelessPhy
set opt(mac)			   Mac/802_11
set opt(qm)			    DropTail	;
set opt(ifq)			   Queue/DropTail
set opt(ll)			      LL
set opt(ant)			    Antenna/OmniAntenna
set opt(adhocRouting)		DSDV	;#DSDV DSR TORA AODV
set opt(disableRTS_CTS) 	1	;#disabled

#For Propagation
set opt(pathlossExp)		2.0	;#path loss exponent
set opt(std_db)			    4.0	;#deviation (dB)
set opt(dist0)			    1.0	;#reference distance
#===============================================================================
#Topology
#===============================================================================
set opt(x)		  670	;
set opt(y)		  670	;
set opt(ifqlen)		50	;#max packet in ifq
set opt(nofmn)		1	;#number of wireless nodes OBS(max 9)
set opt(nofbs)		1	;#number of base stations
set opt(nofsn)		1	;#number of server nodes
set opt(nm_motion)	0	;#random motion of mobile nodes
set opt(nodeDist)	2	;#distance in metres between WLAN nodes
set opt(ecn)		0	;#1 to enable ECN
set opt(adaptive)	true
set opt(minth)		0
set opt(maxth)		0
#==============================================================================
#Evalvid Parametres
#==============================================================================
set opt(videoname)	"akiyo_cif.264"	;
set opt(vbr_rate)	3Mb		;
set opt(q_variants)	30		;
set opt(fps)		30		;
set opt(ra_mtu)		1000		;
set opt(tfrc_pktsize)  	[expr $opt(ra_mtu) + 36 ];#header
set opt(udp_pktsize)	[expr $opt(ra_mtu) + 28 ];#header
set opt(cbr_true)	0		;
set opt(GoP_size)	12		;
#==============================================================================
#Traffic generation
#==============================================================================
set opt(nofTCP)		0	;
set opt(nofWEB)		0	;
set opt(nofFTP)		0	;
set opt(nofUDP)		0	;
set opt(nofTFRC)	0	;

set opt(window)		30	;#for long lived traffic
set opt(tcp_pktsize)	1460
set opt(tcpTick_)	0.01
set opt(doPing) 0 ;#1 to ping servers on startup
#WEB-settings
set opt(webSeed)  0 ;#seed for RNG for web traffic generation
set opt(interPage)  1;#average value for intra page time
set opt(pageSize) 3 ;#objects per page
set opt(nofWebPages)  10  ;#number of pages per session
set opt(nofWebSessions) 4 ;#number of sessions
set opt(webObjectSize)  20  ;
set opt(paretoShape) 1.05  ;#antistrofos me to size tou object
set opt(speed)  1.0
set opt(destx) 26.0

#==============================================================================
#Plotting statistics
#==============================================================================
set opt(out_dir)    nsout
set opt(tf)   $opt(out_dir)/$opt(title).tr
set opt(namtf)    $opt(out_dir)/$opt(title).nam
set opt(doTrace)     1 ;#1 to enable
set opt(nam)    1;#to trace and run nam
set opt(sampleTime) 0.5;#bandwidth samples
set opt(macTrace) OFF
set opt(agentTrace) ON
set opt(routerTrace)  OFF
set opt(movementTrace)  OFF

#==============================================================================
#Link characteristics
#==============================================================================
set opt(errUnit)  packet;#unit of errors per packet
set opt(errRateUL)  0;#rate of errors in unit
set opt(errBurstUL) 0;
set opt(errSlotUL)  0;#time in sec of low error
set opt(errRateDL)  0;
set opt(errBurstDL) 0;
set opt(errSlotDL)  0;

#==============================================================================
set opt(tfrcFB) 1 ;#number of feedback per RTT
set opt(snet_bw)  100Mb ;#link bw on server
set opt(snet_prop)  2ms ;#propagation delay
set opt(core_bw)  100Mb ;#link BW on core net
set opt(core_prop)  2ms ;#propagation delay
set opt(bsnet_bw) 100Mb ;#link BW on base station access net
set opt(bsnet_prop) 2ms ;
set opt(wifi_bw)  11Mb  ;#link BW on wifi net

#=====================END OPTIONS==============================================
#=====================Start procedures=========================================
proc getopt {argc argv} {
#puts2 "................................. the argc is $argc"
  global opt
  for {set i 0} {$i < $argc} {incr i} {
#puts "................................. $argc"
    set arg [lindex $argv $i]
    if {[string range $arg 0 0] != "-"} continue
    set name [string range $arg 1 end]
    set opt($name) [lindex $argv [expr $i+1]]
    puts2 "opt($name):$opt($name)"
#puts "FTP:$opt(nofFTP)"
  }
}

proc puts2 {output} {
  global opt
  if { $opt(verbose)==1} {
    puts $output
  }
}

proc setnofnodes {} {
  global opt ns
  set opt(nofmn) [expr $opt(nofTFRC) + $opt(nofUDP) +$opt(nofFTP) +$opt(nofWEB)]
  
  if { $opt(nofmn)>9} {
    puts2 "nofmn>9.extend address array"
    puts2 "NS exiting..."
    $ns halt
    exit 0
  }
  
  set opt(nofsn) 0
#puts2 "FTP:$opt(nofFTP)"
  if {$opt(nofTFRC)>0} {
    set opt(nofsn) [expr $opt(nofsn) + $opt(nofTFRC)]
  }
  
  if {$opt(nofUDP)>0} {
    incr opt(nofsn)
  }
  
  if {$opt(nofFTP)>0} {
    incr opt(nofsn)
  }
  
  if {$opt(nofWEB)>0} {
    incr opt(nofsn) 
  }
  puts2 "Ordered one server per source type.nof servers: $opt(nofsn)"
}

proc wlan_topo_complex {} {
  global ns nodes opt mn sn rn bs
  puts2 "Building topology..."
  #configuration for Orinoco 802.11b 11Mbps PC card with -> 22.5m range
  Phy/WirelessPhy set Pt_ 0.031622777;#transmit power 0.031622777
  Phy/WirelessPhy set L_  1.0 ;#system loss factor
  Phy/WirelessPhy set bandwidth_ 1  ;#$opt(wifi_bw)
  Phy/WirelessPhy set freq_ 2.472e9 ;#channel 13=>2.472GHz
  Phy/WirelessPhy set CPThresh_ 10.0 ;#simultaneos packets
  Phy/WirelessPhy set CSThresh_ 5.011872e-12  ;#carrier sending 
  Phy/WirelessPhy set RXThresh_ 5.82587e-09 ;#reception
  
  #ns does not support ARF,dynamic rate adjustment
  Mac/802_11 set dataRate_ $opt(wifi_bw)
  #commercial packets use RTS/CTS above a threshold
  if { $opt(disableRTS_CTS)==1 } {
    puts2 "Disabling RTS/CTS"
    Mac/802_11 set RTSThreshold 3000
  }
  Mac/802_11 set basicRate_ 1Mb ;#for broadcast
  
  #address setup
  $ns node-config -addressType hierarchical
  AddrParams set domain_num_ 2;
  if {$opt(nofbs)>1} {
    puts2 "no support for more than one base station"
    puts2 "NS exiting"
    exit 0
  }
  lappend cluster_num 1 2 ;
  
  AddrParams set cluster_num_ $cluster_num
  
  #set nodes per cluster
  #lappend eilastlevel [expr $opt(nofsn) + 1] 1 [expr $opt(nofmn) + 1]
  #AddrParams set nodes_num_ $eilastlevel
  
  set topo [new Topography]
  $topo load_flatgrid $opt(x) $opt(y) 
  create-god [expr $opt(nofmn) + $opt(nofbs)]
  
  #creating wired nodes=> sn + rn
  #set rn(0) [$ns node {0.0.0}]
  #set rn(1) [$ns node {1.0.0}]
  #puts2 "Router nodes:"
  #puts2 [$rn(0) node-addr]
  #puts2 [$rn(1) node-addr]
  #create as many sn-addresses as needed
  
  #if { $opt(nofsn)>9 } {
   # puts2 "create for-loop to address more server nodes"
    #puts2 "NS exiting"
    #$ns halt
  #}
  
  #set sn_addr {0.0.1 0.0.2 0.0.3 0.0.4 0.0.5 0.0.6 0.0.7 0.0.8 0.0.9}
  #puts2 "server nodes:"
  #for {set i 0} {$i<$opt(nofsn)} {incr i} {
   # set sn($i) [$ns node [lindex $sn_addr $i]]
    #puts2 [$sn($i) node-addr]
  #}
  
  if {$opt(prop) == "Propagation/Shadowing"} {
    #values for model
    Propagation/Shadowing set pathlossExp_ $opt(pathlossExp)
    Propagation/Shadowing set std_db_ $opt(std_db)
    Propagation/Shadowing set dist0_  $opt(dist0)
    Propagation/Shadowing set seed $opt(seed)
    
    puts2 "values for shadownig propagation are set"
  }
  
 #ns configuring
$ns node-config -adhocRouting $opt(adhocRouting) \
        -llType $opt(ll) \
        -macType $opt(mac) \
        -ifqType $opt(ifq) \
        -ifqLen $opt(ifqlen) \
        -propInstance [new $opt(prop)] \
        -antType $opt(ant) \
        -phyType $opt(netif) \
        -wiredRouting ON \
        -channel [new $opt(chan)] \
        -topoInstance $topo \
        -agentTrace $opt(agentTrace) \
        -routerTrace $opt(routerTrace) \
        -macTrace $opt(macTrace) \
        -movementTrace $opt(movementTrace)
        #-propType $opt(prop)
        
        
  #create base-station
  if {$opt(nofbs)>1} {
    puts2 "create for-loop for more"
    puts2 "Ns exiting"
    $ns halt
    exit 0
  } else {
    #creating and setting addresses
    set bs(0) [$ns node {1.1.0}]
    #bs is not moving
    $bs(0) random-motion 0
    $bs(0) set X_ 1.0
    $bs(0) set Y_ 1.0
    $bs(0) set Z_ 0.0
    puts2 "Base station nodes:"
    puts2 [$bs(0) node-addr]
  }
  
#configure mobile nodes
$ns node-config -wiredRouting OFF

  if {$opt(nofbs)>1} {
    puts2 "create for loop to address mobile nodes"
    puts2 "NS exiting"
    $ns halt
    exit 0
  } else {
    set x_pos 0.0
    set y_pos 0.0
   if {$opt(nofmn)>9} {
      puts2 "for loop for more mobile"
      puts2 "NS exiting"
      $ns halt
      exit 0
    }
    
    set adr {1.1.1 1.1.2 1.1.3 1.1.4 1.1.5 1.1.6 1.1.7 1.1.8 1.1.9}
    puts2 "Mobile nodes:"
    for {set j 0} {$j< $opt(nofmn)} {incr j} {
      set mn($j) [$ns node [lindex $adr $j]]
      puts2 [lindex $adr $j] 
      
      $mn($j) random-motion $opt(nm_motion)
      $mn($j) set X_ 22.0 #23.0
      $mn($j) set Y_ 3.0 #5.0
      $mn($j) set Z_ 0.0 #2.0
      
      set x_pos [expr $x_pos + $opt(nodeDist)/2]
      set y_pos [expr $y_pos + $opt(nodeDist)/2]
      $mn($j) base-station [AddrParams addr2id [$bs(0) node-addr]]
      $ns initial_node_pos $mn($j) 20  
    }
  }
  
  #link servers to first core router
  #set link_angle 135
  #set angle_offset [expr 90 / $opt(nofsn)]
  #for {set k 0} {$k<$opt(nofsn)} {incr k} {
   # $ns duplex-link $sn($k) $rn(0) $opt(snet_bw) $opt(snet_prop) $opt(qm)
    #$ns duplex-ling-op $rn(0) $sn($k) orient $link_angle
    #set link_angle [expr $link_angle + $angle_offset]
  #}
  #core link
#$ns duplex-link $rn(0) $rn(1) $opt(core_bw) $opt(core_prop) $opt(qm)
  #$ns duplex-ling-op $rn(0) $rn(1) orient right
  
  #link base stations to seconde core router
# for {set l 0} {$l<$opt(nofbs)} {incr l} {
#   $ns duplex-link $rn(1) $bs($l) $opt(bsnet_bw) $opt(bsnet_prop) $opt(qm)
#   $ns duplex-link-op $rn(1) $bs($l) orient right-up
# }
  puts2 "done topology"
}

proc ping {} {
  global opt ns mn sn
  set tmp 0
  set tmp2 0
  
  for {set m $tmp2} { $m<$opt(nofFTP) } {incr m} {
    set ping_downstream [$ns create-connection Ping $sn($tmp) Ping $mn($m) 9]
    set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
    puts2 "FTP-link: ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back"
    $ping_downstream oneway
    $ping_upstream oneway
    $ns after 0.1 "$ping_downstream send"
    $ns after 0.2 "$ping_upstream send"
    if {$m==[expr $opt(nofFTP)-1]} {
      incr tmp
    }
    incr tmp2
  }


  set tmp3 $tmp2
  for {set m $tmp2} {$m<$opt(nofWEB)} {incr m} {
    set ping_downstream [$ns create connection Ping $sn($tmp) Ping $mn($m) 9]
    set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
    puts2 "WEB-link:ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back!"
    $ping_downstream oneway
    $ping_upstream oneway
    $ns after 0.3 "$ping_downstream send"
    $ns after 0.4 "$ping_upstream send"
    if {$m== [expr $opt(nofWEB)-1]} {
      incr tmp
    }
    incr tmp2
  }
  
  set tmp3 $tmp2
#puts2 "GGEEEEEEEEEEEEEEEEIIIIIIIIIIIIIIIIIIIIIIIAAAAAAAAAAAAAAAA"
  for { set m $tmp2 } { $m< [expr $opt(nofUDP) + $tmp3] } {incr m} {
    #puts2 "Prin kanei ping"
    set ping_downstream [$ns create-connection Ping $sn($tmp) Ping $mn($m) 9]
    #puts2 "afou kanei ping..................."
    set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
    puts2 "UDP-link: ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back!"
    $ping_downstream oneway
    #puts2 "edo???????????????????"
    $ping_upstream oneway
    #puts2 "edo ftanoume?????????????????????"
    $ns after 0.5 "$ping_downstream send"
    $ns after 0.6 "$ping_upstream send"
    if { $m == [expr $opt(nofUDP) + $tmp3 -1] } {
      incr tmp
    }
    incr tmp2
  }

  set tmp3 $tmp2
  for {set m $tmp2} {$m< [expr $opt(nofTFRC) + $tmp3]} {incr m} {
    set ping_downstream [$ns create-connection Ping $sn($tmp) Ping $mn($m) 9]
    set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
    puts2 "UDP-link: ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back!"
    $ping_downstream oneway
    $ping_upstream oneway
    $ns after 0.7 "$ping_downstream send"
    $ns after 0.8 "$ping_upstream send"
    if {$m==[expr $opt(nofTFRC) + $tmp3 -1]} {
      incr tmp
    }
    incr tmp2
  }
}

proc stop {} {
  global ns opt mn sn rn bs
  
  for {set j 0} {$j<$opt(nofmn)} {incr j} {
    $ns at $opt(stop).0000010 "$mn($j) reset";
  }
#for {set i 0} {$i<$opt(nofsn)} {incr i} {
#   $ns at $opt(stop).0000010 "$sn($i) reset";
# }
  $ns at $opt(stop).1 "puts2 \"NS exiting\"; $ns halt"
#get data from trace file
	#exec awk {
	#	{ if (($1=="-"&& $5=="tcp") || ($1=="-" && $5=="cbr")) {
	#		old_data=old_data + $6
	#		print $2, old_data*8.0/$2/1000000
	#	  }
	#	}
#} trace_file.out >throughput.data

	
#exec xgraph throughput.data &
#exec xgraph $opt(out_dir)/$opt(title).tr -geometry 800x400 &
  exit 0
}

proc record {sink bwt} {
  global opt
  set ns [Simulator instance]
  set time $opt(sampleTime)
  set bw [$sink set bytes_]
  set now [$ns now]
  puts $bwt "$now [expr $bw/$time*8/1000000]"
  $sink set bytes_ 0
  $ns at [expr $now+$time] "record $sink $bwt"
}

proc prepare_evalvid_trace {} {
  global ns opt trace_file trace_file_id
  puts2 "--------------trace prepare start-------------------"
  puts2 "Start making GoP and frame trace file for $opt(q_variants) rate variatns"
  for {set i 1} {$i<=$opt(q_variants)} {incr i} {
    set original_file_name($i) nsin/st_$opt(videoname)_Q[expr $i+1].txt
    set original_file_id($i) [open $original_file_name($i) r]
  }
  set trace_file_name $opt(out_dir)/video2.dat
  set trace_file_id [open $trace_file_name w]
  set trace_file [new vbrTracefile2]
  $trace_file filename $trace_file_name
  set frame_count 0
  set last_time 0
  
  #set original_file_id $original_file_id(1)
  set source_select 1
  set frame_size_file $opt(out_dir)/frame_size.dat
  set gop_size_file $opt(out_dir)/gop_size.dat
  set frame_size_file_id [open $frame_size_file w]
  set gop_size_file_id [open $gop_size_file w]
  
  for {set i 1} {$i<=$opt(q_variants)} {incr i} {
    set frame_size($i) 0
    set gop_size($i) 0
  }
  set gop_numb 0
  
  while {[eof $original_file_id(1)]==0} {
    for {set i 1} {$i<=$opt(q_variants)} {incr i} {
      gets $original_file_id($i) current_line($i)
    }
    scan $current_line(1) "%d%s%d%s%s%s%d%s" no_ frametype_ length_ tmp1_ tmp2_ tmp3_ tmp4_ tmp5_
    #puts2 "$no_ frametype_ $length_ $tmp1_ $tmp2_ $tmp3_ $tmp4_ $tmp5_"
    
    set time [expr 1000 * 1000/$opt(fps)];
    if { $frametype_ =="I"} {
      set type_v 1
      set time 0
    }
    if {$frametype_=="P"} {
      set type_v 2
    }
    if {$frametype_ =="B"} {
      set type_v 3
    }
    if {$frametype_ =="H"} {
      set puts_string "$gop_numb"
      for {set i 1} {$i<=$opt(q_variants)} {incr i} {
        set puts_string "$puts_string $gop_size($i)"
      }
      puts $gop_size_file_id $puts_string
      incr gop_numb
      set type_v 0;
    }
    
    set puts_string "$no_"
    for {set i 1} {$i<=$opt(q_variants)} {incr i} {
      set puts_string "$puts_string $gop_size($i)"
    }
    puts $frame_size_file_id $puts_string
    
    for {set i 1} {$i<=$opt(q_variants)} {incr i} {
      scan $current_line($i) "%d%s%d%s%s%s%d%s" no_ frametype_ length($i) tmp1_ tmp2_ tmp3_ tmp4_ tmp5_
      set gop_size($i) [expr $gop_size($i) + $length($i)]
    }
    
    set puts_string "$time $length_ $type_v $opt(ra_mtu)"
    for {set i 2} {$i<= $opt(q_variants)} {incr i} {
      set puts_string "$puts_string $length($i)"
    }
    puts $trace_file_id $puts_string
    if {$frametype_ !="H"} {
      incr frame_count
    }
  }
  puts2 "#of frames written to GoP and Frame trace files: $frame_count"
  close $trace_file_id;
  puts2 "---------trace prepare stop-----------------------"
}

##proc ping {} {
##global opt ns mn sn bs
## set tmp 0
##set tmp2 0
  
  #for {set m $tmp2} { $m<$opt(nofFTP) } {incr m} {
   # set ping_downstream [$ns create-connection Ping $sn($tmp) Ping $mn($m) 9]
    #set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
    #puts2 "FTP-link: ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back"
    #$ping_downstream oneway
    #$ping_upstream oneway
    #$ns after 0.1 "$ping_downstream send"
    #$ns after 0.2 "$ping_upstream send"
    #if {$m==[expr $opt(nofFTP)-1]} {
    #  incr tmp
    #}
    #incr tmp2
  #}


  #set tmp3 $tmp2
  #for {set m $tmp2} {$m<$opt(nofWEB)} {incr m} {
   # set ping_downstream [$ns create connection Ping $sn($tmp) Ping $mn($m) 9]
    #set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
    #puts2 "WEB-link:ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back!"
    #$ping_downstream oneway
    #$ping_upstream oneway
    #$ns after 0.3 "$ping_downstream send"
    #$ns after 0.4 "$ping_upstream send"
    #if {$m== [expr $opt(nofWEB)-1]} {
     # incr tmp
    #}
    #incr tmp2
  #}
##set tmp3 $tmp2
#puts2 "GGEEEEEEEEEEEEEEEEIIIIIIIIIIIIIIIIIIIIIIIAAAAAAAAAAAAAAAA"
 # for { set m $tmp2 } { $m< [expr $opt(nofUDP) + $tmp3] } {incr m} {
##puts2 "Prin kanei ping"
##set ping_downstream [$ns create-connection Ping $bs(0) Ping $mn(0) 9]
## puts2 "afou kanei ping..................."
##  set ping_upstream [$ns create-connection Ping $mn(0) Ping $bs(0) 9]
##  puts2 "UDP-link: ping from [$bs(0) node-addr] to [$mn(0) node-addr] and back!"
##  $ping_downstream oneway
##  puts2 "edo???????????????????"
##  $ping_upstream oneway
##  puts2 "edo ftanoume?????????????????????"
##  $ns after 0.5 "$ping_downstream send"
##  $ns after 0.6 "$ping_upstream send"
# if { $m == [expr $opt(nofUDP) + $tmp3 -1] } {
    #  incr tmp
   # }
   # incr tmp2
  #}

  #set tmp3 $tmp2
  #for {set m $tmp2} {$m< [expr $opt(nofTFRC) + $tmp3]} {incr m} {
  #  set ping_downstream [$ns create-connection Ping $sn($tmp) Ping $mn($m) 9]
  #  set ping_upstream [$ns create-connection Ping $mn($m) Ping $sn($tmp) 9]
  #  puts2 "UDP-link: ping from [$sn($tmp) node-addr] to [$mn($m) node-addr] and back!"
  #  $ping_downstream oneway
  #  $ping_upstream oneway
   # $ns after 0.7 "$ping_downstream send"
   # $ns after 0.8 "$ping_upstream send"
   # if {$m==[expr $opt(nofTFRC) + $tmp3 -1]} {
   #   incr tmp
   # }
   # incr tmp2
 # }
##}

proc attach_FTP_traffic { startnode endnode connection_number } {
	global ns opt tcp tcp_in_use ftp_server
	$startnode color red
	$endnode color red
	set start_id [$startnode id]
	set end_id [$endnode id]
	set tcp($connection_number) [new Agent/TCP]
	$tcp($connection_number) set fid_ 40
	set tcpsink($connection_number) [new Agent/TCPSink]
	$ns attach-agent $startnode $tcp($connection_number)
	$ns attach-agent $endnode $tcpsink($connection_number)
	$ns connect $tcp($connection_number) $tcpsink($connection_number)
	set ftp_server($connection_number) [new Application/FTP]
	$ftp_server($connection_number) attach-agent $tcp($connection_number)

	set bwt [open $opt(out_dir)/bwt.FTP.$connection_number.tr w] ;
	$ns at 0.0 "record $tcpsink($connection_number) $bwt"
	puts2 "added TCP connection number $connection_number between nodes $start_id and $end_id"
}

#==============================================================================
#Add Evalvid-RA sources
#==============================================================================
proc attach_TFRC_traffic {startnode endnode connection_number} {
  global ns tfrc opt trace_file vbr_in_use vbr
  $startnode color green
  $endnode color green
  puts2 "eimai sto TFRC.................................FDADFASDFASDFSDFSD"
  set start_id [$startnode id]
  set end_id [$endnode id]
  set tfrc_agent($connection_number) [new Agent/TFRC]
  puts "connection_num: $connection_number"
# set printStatus_ true
	#puts2 "$connection_number !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  $tfrc_agent($connection_number) set fid_ $connection_number
  $ns attach-agent $startnode $tfrc_agent($connection_number)
  set vbr($vbr_in_use) [new Application/Traffic/eraVbrTrace]
  $vbr($vbr_in_use) attach-agent $tfrc_agent($connection_number)
  
  $tfrc_agent($connection_number) set packetSize_ $opt(tfrc_pktsize);
  $tfrc_agent($connection_number) set TOS_field_ 1
  
  if {$connection_number<15} {
    $tfrc_agent($connection_number) set_filename $opt(out_dir)/sd_be.tfrc.$connection_number
  }
  
  $vbr($vbr_in_use) set running_ 0
  $vbr($vbr_in_use) set r_ $opt(vbr_rate);
  
  
  puts2 "r_ = $opt(vbr_rate)"
  $vbr($vbr_in_use) attach-tracefile $trace_file
  $vbr($vbr_in_use) set b_ 1.5
  $vbr($vbr_in_use) set q_ 4
  $vbr($vbr_in_use) set Gop_ $opt(GoP_size)
  $vbr($vbr_in_use) set fps_ $opt(fps)
  $vbr($vbr_in_use) set isTFRC_ 1
  
  set tfrcsink($connection_number) [new Agent/TFRCSink]
  $ns attach-agent $endnode $tfrcsink($connection_number)
  $ns connect $tfrc_agent($connection_number) $tfrcsink($connection_number)
  
  if {$connection_number== 0} {
    $tfrcsink($connection_number) set_trace_filename $opt(out_dir)/rd_be.tfrc.$connection_number
  }
  #set trace_file [open trace_file w]
  #$ns at 15.0 "$ns trace-queue $startnode $endnode $trace_file"
  set bwt [open $opt(out_dir)/bwt.TFRC.$connection_number w]
  $ns at 0.0 "record $tfrcsink($connection_number) $bwt"
  puts2 "added TFRC connection number $connection_number (vbr($vbr($vbr_in_use)) between nodes $start_id and $end_id"
  incr vbr_in_use
}

proc attach_UDP_traffic {startnode endnode connection_number} {
  global ns opt udp vbr_in_use vbr trace_file
  $startnode color blue
  $endnode color blue
  set start_id [$startnode id]
  set end_id [$endnode id]
  set udp($connection_number) [new Agent/eraUDP]
  $udp($connection_number) set fid_ $connection_number
  $ns attach-agent $startnode $udp($connection_number)
  set vbr($vbr_in_use) [new Application/Traffic/eraVbrTrace]
  $vbr($vbr_in_use) attach-agent $udp($connection_number)
  
  $udp($connection_number) set packetSize_ $opt(udp_pktsize)
  $udp($connection_number) set TOS_field_ 1 ;
  if {$connection_number<15} {
    $udp($connection_number) set_filename $opt(out_dir)/sd_be.udp.$connection_number
  }
  $vbr($vbr_in_use) set running_ 0
  $vbr($vbr_in_use) set r_ $opt(vbr_rate);
  
  $vbr($vbr_in_use) attach-tracefile $trace_file
  
  $vbr($vbr_in_use) set b_ 1.5
  $vbr($vbr_in_use) set q_ 1
  $vbr($vbr_in_use) set GoP_ $opt(GoP_size)
  $vbr($vbr_in_use) set fps_ $opt(fps)
  $vbr($vbr_in_use) set isTFRC_ 0
  
  set udpsink($connection_number) [new Agent/eraUdpSink]
  $ns attach-agent $endnode $udpsink($connection_number)
  $ns connect $udp($connection_number) $udpsink($connection_number)
  if {$connection_number == 0} {
    $udpsink($connection_number) set_trace_filename $opt(out_dir)/rd_be.udp.$connection_number
  }
  $udpsink($connection_number) set bytes_ 0
  set bwt [open $opt(out_dir)/bwt.UDP.$connection_number.tr w];
  
  $ns at 0.0 "record $udpsink($connection_number) $bwt"
  puts2 "added UDP connection number $connection_number (vbr($vbr_in_use)) between nodes $start_id and $end_id"
  incr vbr_in_use
}


#==============================================================================
#adaptive ra
#==============================================================================
Agent/TFRC instproc tfrc_ra {bytes_per_sec backlog} {
  global vbr ns opt sn_in_use vbr_in_use
  set now [$ns now]
  $self instvar node_
  set node_id [$node_ id]
  
#set vbr_number [expr $node_id  + $opt(nofUDP) -2];
  if {$opt(nofFTP)>0} {
    set vbr_number [expr $vbr_number - 1]
  }
  if {$opt(nofWEB)>0} {
    set vbr_number [expr $vbr_number - 1]
  }
  if {$opt(nofUDP)>0} {
    set vbr_number [expr $vbr_number - 1]
  }
  puts2 "tfrc_ra behandler ack til vbr($vbr_in_use) (node($node_id)) B/s: $bytes_per_sec"
  #puts "In TFRC instproc. rate= $bytes_per_sec (B/s), node_id= $node_id"
  #puts "TCL: before vbr($vbr_number) TFRC_rateadapt rate=$bytes_per_sec node=$node_id"
  
  $ns at [expr $now] "$vbr(0) TFRC_rateadapt $bytes_per_sec $node_id $backlog"
  #puts "TCL: after vbr($vbr_number) TFRC_rateadapr rate= $bytes_per_sec node=$node_id"
}

#==============================================================================
#Function for receiving pings
#==============================================================================
Agent/Ping instproc recv {from seq ff bf} {
  $self instvar node_
  puts "node [$node_ id] received ping answer from $from seq $seq with forward delay $ff and backward $bf ms."
  #puts $rttf "$seq [expr $ff/1000] [expr $bf/1000]"
}

#===========================end procedures=====================================
#===========================Start exec:Environment=============================

set ns [new Simulator]

getopt $argc $argv

puts2 "\n--------new sim---------"

if {$opt(seed)>-1} {
  puts2 "seeding random number generator with $opt(seed)"
  ns-random $opt(seed)
}

#====Trace====
$ns use-newtrace
if {$opt(doTrace)} {
  set tf [open $opt(tf) w]
  $ns trace-all $tf
}
if {$opt(nam)} {
  set nf [open $opt(namtf) w]
  $ns namtrace-all-wireless $nf 250 250
}

$ns color 40 red
$ns color 41 blue
$ns color 42 green
$ns color 43 chocolate

#=========set TFRC========================
if {$opt(nofTFRC) > 0} {
  Agent/TFRC set ss_changes_ 1;
  Agent/TFRC set slow_increase_ 1;
  Agent/TFRC set rate_init_ 2
  Agent/TFRC set rate_init_option_ 2;
  Agent/TFRC set SndrType_ 1
  Agent/TFRC set oldCode_ false
  Agent/TFRC set packetSize_ $opt(tfrc_pktsize)
  Agent/TFRC set maxqueue_ 500
  Agent/TFRC set printStatus_ true
  Agent/TFRC set ecn_ $opt(ecn)
  #Agent/TFRC set useHeaders_ false   #has been removed from tfrc.cc
  #Agent/TFRCSink set NumFeedback_ $opt(tfrcFB)
}

setnofnodes;
wlan_topo_complex;

set mn_in_use 0
#set sn_in_use 0
set vbr_in_use 0

if {$opt(nofTFRC)>0 || $opt(nofUDP)>0} {
  prepare_evalvid_trace
}

if {$opt(nofFTP)>0} {
  for {set i 0} {$i<$opt(nofFTP)} {incr i} {
    attach_FTP_traffic $bs(0) $mn($mn_in_use) $i
   incr mn_in_use
  }
#incr sn_in_use
}

#if {$opt(nofWEB)>0} {
# PagePool/WebTraf set FID_ASSIGNING_MODE_ 2
# set pool [new PagePool/WebTraf]
# $pool set-num-client $opt(nofWEB)
# $pool set-num-server 1;
# $pool set sameFid_ 2
# 
# for {set i 0} {$i<$opt(nofWEB)} {incr i} {
#   attach_WEB_traffic $sn($sn_in_use) $mn($mn_in_use) $i
#   incr mn_in_use
# }
# incr sn_in_use
#}

if {$opt(nofUDP)>0} {
  for {set i 0} {$i<$opt(nofUDP)} {incr i} {
    attach_UDP_traffic $bs(0) $mn($mn_in_use) $i
    incr mn_in_use
  }
  #incr sn_in_use
}

if {$opt(nofTFRC)>0} {
  for {set i 0} {$i<$opt(nofTFRC)} {incr i} {
    attach_TFRC_traffic $bs(0) $mn($mn_in_use) $i
    incr mn_in_use
#$ns at 14 "$mn(0) setdest 10.0 3.0 0.0 "
#incr bs_in_use
  }
  #incr sn_in_use
}

#==============================================================================
#Start resources
#==============================================================================
if {$opt(doPing)==1} {
  ping
}
for {set i 0} {$i<$opt(nofFTP)} {incr i} {
  $ns at [expr 12] "$ftp_server($i) start"
  $ns at [expr 50] "$ftp_server($i) stop"
}
#$ns at 9.98 "$vbr(0) start"
puts "nofUDP: $opt(nofUDP)"
for {set i 0} {$i<$opt(nofUDP)} {incr i} {
  $ns at 10 "$vbr($i) start"
  $ns at 50 "$vbr($i) stop"
	#set trace_file [open trace_file w]
  	#$ns at 15.0 "$ns trace-queue $bs(0) $mn $trace_file"
}
#$ns at 9.8 "$vbr($opt(nofUDP)) start"
#for {set i $opt(nofUDP)} {$i<$vbr_in_use} {incr i} {
#$ns at 14 "$mn(0) setdest 200.0 100.0 0.0 "
	$ns at 10 "$vbr(0) start"
$ns at 17 "$mn(0) setdest $opt(destx) 3.0 $opt(speed)"
#$ns at 17 "$mn(0) setdest 24.0 3.0 1.0"
  #$ns at 50 "$vbr($i) stop"
	#set trace_file [open trace_file w]
  	#$ns at 15.0 "$ns trace-queue $bs(0) $mn(0) $trace_file"
#}

$ns at $opt(stop) "stop"
puts2 ""
puts2 "-------------------Starting simulation-----------------"
$ns run
